(* Relation flic->joueur.
   Les flics et les joueurs sont repers par un entier (qui ne change pas). *)

type map

val init: string array -> map
  (* Nom des flics au dpart. Chacun a son propre joueur. *)

val brains: map -> int list
  (* La liste des joueurs actifs. *)

val cop_num: map -> string -> int
  (* Numero du flic. *)

val controller: map -> string -> int
  (* Numero du joueur qui controle un flic. *)

val controller_i : map -> int -> int

val cop_name: map -> int -> string
  (* Nom du flic. *)

val integrate: map -> Message.sc list -> (int * int) list
  (* Intgre (en place) les infos d'un world-msg pour dtecter les prises
     de controle. La liste stocke les couples (perdant,gagnant)
     o [perdant] est le numro d'un joueur ripoux qui s'est fait dnoncer
     et [gagnant] est le numro du joueur qui rcupre les policiers
     du perdant. *)

val controled_by: map -> int -> int list
  (* Liste des flics controls par un joueur (vide si le numero
     est celui d'un flic control). *)
    
val is_active: map -> int -> bool
