(* $Id: incorrect_cop.ml,v 1.1 2005/06/26 20:22:40 doligez Exp $ *)

open Message
open Printf
open Topology

let this_cop me env w () =
  let info = env.Cops_api.env_info
  and topo = env.Cops_api.env_topo
  and drawer = env.Cops_api.env_drawer in

  let infos = Cop_informer.compute_inform info in

  let _informs = Cops_api.cop_inform me env infos in
(*
    eprintf "set sizes = %d %d\n"
      (NS.cardinal (Info.get_possible info))
      (NS.cardinal (Info.get_certain info));
    flush stderr;
*)
    Draw.display_node_sets drawer
      (Info.get_possible info)
      (Info.get_certain info);

    let my_move,plan = Planify.damien_plan info in
    let _plans = Cops_api.cop_plan me plan in

  (*
    let myvote =
      let cops = Array.to_list topo.cops_name in
      let pref x y =
        if x = topo.name then -1 else if y = topo.name then 1 else 0
      in
      List.sort pref cops
    in *)
  let vote_res = Cops_api.cop_vote me (Voting.vote topo.name) in
  Voting.count vote_res;
    let (my_type, my_node) = my_move in
    let new_type =
      if Random.bool () then my_type else
        begin
          eprintf "try bad type\n"; flush stderr;
          match my_type with
          | Cop_foot -> Cop_car
          | _ -> Cop_foot
        end
    in
    let new_node =
      if Random.bool () then my_node else begin
        eprintf "try bad node\n"; flush stderr;
        let nods = env.Cops_api.env_topo.t_nods in
        let n = Random.int (Array.length nods) in
        nods.(n)
      end
    in
    ((new_type, new_node), ())

let () =
  Cops_api.register_cop "incorrect_cop"
    { cops_init = (fun _ env -> Voting.init env.Cops_api.env_wsk);
      Cops_api.cops_job  = this_cop;
      Cops_api.cops_ptype = Cop_foot;
    }
