(* $Id: info.mli,v 1.21.2.7 2005/07/10 13:36:46 frisch Exp $ *)

open Message;;
open Topology;;

type info

val init : topo -> Draw.t -> info
val drawer : info -> Draw.t
val topo : info -> topo

val am_i_dirty: info -> bool
val brains: info -> Brains.map

val get_ripoux: info -> int list
  (* Liste des joueurs detects comme tant ripoux, et encore
     actifs. *)

val get_my_cops : info -> int list
val get_other_cops : info -> int list
(*
val get_cop : info -> string -> nod * ptype
*)
val get_cop_i : info -> int -> nod * ptype
(*
val get_me  : info -> nod * ptype
*)


val current_world : info -> int
val plan_for_world : info -> int

val add_world : info -> world -> info
val add_informs : info -> (string * inf list) list -> unit

val get_possible : info -> NS.t;;
val get_certain : info -> NS.t;;

val map_cops : info -> (string -> int -> nod -> ptype -> 'a) -> 'a list
val iter_cops : info -> (string -> int -> nod -> ptype -> unit) -> unit


(* Change the type of cops on headquarters so that we reach
   a 2 cars, 3 cops ratio *)
val change_cop : info -> (int * ptype) list -> info

val debug_trusted : info -> unit;;
val get_robber : info -> nod option
val robbed: info -> int
