(* $Id: lexer.mll,v 1.2.4.2 2005/07/09 16:29:44 frisch Exp $ *)

{
open Parser;;
open Printf;;
}

rule token = parse
  | (' ' | '\t')
            { token lexbuf }
  | ('\n' | "\r\n")
            { EOL }
  | [ '-' 'a'-'z' 'A'-'Z' '0'-'9' '_' '#' '(' ')']+
            { IDENT (Lexing.lexeme lexbuf) }
  | "bv/"   { BVCL }
  | "bv:"   { BV }
  | "bv\\"  { BVOP }
  | "cop:"  { COP }
  | "edg/"  { EDGCL }
  | "edg:"  { EDG }
  | "edg\\" { EDGOP }
  | "ev/"   { EVCL }
  | "ev:"   { EV }
  | "ev\\"  { EVOP }
  | "from/" { FROMCL }
  | "from:" { FROM }
  | "from\\" { FROMOP }
  | "inf/"  { INFCL }
  | "inf:"  { INF }
  | "inf\\" { INFOP }
  | "mov\\" { MOVOP }
  | "mov/"  { MOVCL }
  | "mov:"  { MOV }
  | "name:" { NAME }
  | "nod/"  { NODCL }
  | "nod:"  { NOD }
  | "nod\\" { NODOP }
  | "nowinner:" { NOWINNER }
  | "pl/"   { PLCL }
  | "pl:"   { PL }
  | "pl\\"  { PLOP }
  | "plan/" { PLANCL }
  | "plan:" { PLAN }
  | "plan\\" { PLANOP }
  | "rbd:"  { RBD }
  | "reg:"  { REG }
  | "robber:" { ROBBER }
  | "smell:" { SMELL }
  | "vote/" { VOTECL }
  | "vote:" { VOTE }
  | "vote\\" { VOTEOP }
  | "winner:" { WINNER }
  | "wor/"  { WORCL }
  | "wor:"  { WOR }
  | "wor\\" { WOROP }
  | "wsk/"  { WSKCL }
  | "wsk\\" { WSKOP }

  | "dc/"  { DCCL }
  | "dc:"  { DC }
  | "dc\\" { DCOP }
  | "sc/"  { SCCL }
  | "sc:"  { SC }
  | "sc\\" { SCOP }
  | "fac/"  { FACCL }
  | "fac:"  { FAC }
  | "fac\\" { FACOP }

  | "cmov\\" { CMOVOP }
  | "cmov/" { CMOVCL }
  | "acc\\" { ACCOP }
  | "acc/"  { ACCCL }

  | "turncoat:" { TURNCOAT }
  | "straight-arrow:" { STRAIGHTARROW }

  | "ofc:" { OFC }
  | "ofc\\" { OFCOP }
  | "ofc/" { OFCCL }

  | "nottelling:" { NOTTELLING} 
  | "accused:" { ACCUSED }

  | eof { EOF }
  | _ { failwith (sprintf "bad character: '%S'" (Lexing.lexeme lexbuf)) }
