let hide_stderr () =
  let fd = Unix.openfile "/dev/null" [Unix.O_WRONLY] 0o644 in
  Unix.dup2 fd Unix.stderr;
  Unix.close fd

let main () =
  let cop  = ref "damien_cop" in
  Arg.parse [
    "-cop", Arg.Set_string cop, (Printf.sprintf "<name> : choose cop to run (default:%s)" !cop);
    "-no_err", Arg.Unit hide_stderr, " : hide stderr";
    "-no_x11", Arg.Clear Draw.enabled, " : no x11 display";
    "-no_timeouts", Arg.Clear Utils.timeouts, " : disable timeouts";
    "-random", Arg.Int Random.init, "<seed> : seed PRNG";
  ] (fun _ -> failwith "No anonymous argument") "B8 cops";
  Cops_api.run_cop stdin !cop

let () =
  (*try*) main ()
  (*with e ->
    Printf.fprintf stderr "Exception: %s\n" (Printexc.to_string e);
    flush stderr;
    exit 2
*)
