(* $Id: moveChooser.ml,v 1.3 2005/06/26 20:42:55 regisgia Exp $ *)

open Message
open Printf
open Info
open Cops_api
open Topology

(* Le but est de dterminer le mouvement a jouer au tour suivant en 
   fonction de ce que nous demande le plan dans eventuellement 
   plusieurs tours.
*)
let find_move_according_to_plan fw env world user_infos chosen_plan plan =
  let node, ptype = Info.get_me env.env_info in
  let my_name = env.env_wsk.wsk_name in
    Printf.eprintf "NAME %s\n%!" my_name;
    (* Ce qui me concerne. *)
  let about_me_in_the_future = 
    List.filter 
      (fun plan -> 
	 plan.plan_bot = my_name && plan.plan_world > world.wor_wor 
	  && Plan.is_valid_plan world env plan
      )
      plan
  in
  let about_me_in_the_future = 
    (* Si le plan vote ne parle pas de moi alors je fais ce qui est
       decide. On pourrait etre plus fin en choisissant un bon coup
       par rapport au plan. *)
    if about_me_in_the_future = [] then
      try 
	List.filter (fun plan -> plan.plan_bot = my_name) plan
      with Not_found -> failwith "Our plan is supposed to talk about me."
    else  
      about_me_in_the_future
  in
    (* about_me is non empty. *)
    (* La strategie la plus simple pour le moment : on cherche la suggestion 
       la plus proche dans le temps. *)
  let _, closest_plan = List.fold_left (fun (min, min_plan) plan -> 
			   if min > plan.plan_world then
			     (plan.plan_world, plan)
			   else 
			     (min, min_plan)) 
    (max_int, default_plan) about_me_in_the_future
  in
    List.iter (fun plan -> Printf.eprintf "ABOUT_ME:"; dump_plan plan) 
      about_me_in_the_future;
    dump_plan closest_plan;
    (* Si la meillieure strategie la plus proche parle du prochain tour alors 
       on l'applique *)
    if closest_plan.plan_world = world.wor_wor + 1 then
      (closest_plan.plan_ptype, get_node env.env_topo closest_plan.plan_loc)
    else
      Plan.next_move_to_accomplish fw world env closest_plan ptype node 
