(* $Id: plan.ml,v 1.3 2005/06/26 20:42:55 regisgia Exp $ *)

open Message
open Info
open Topology
open Cops_api
open Fw

let is_valid_move env move = 
  let node, ptype = get_me env.env_info in
  let dest_ptype, dest_node = move in
    (* En supposant qu'on puisse changer et bouger en meme temps. *)
    (* FIXME: est-on sur que ca ne demande pas deux tours de changer et 
       bouger *)
    (* FIXME: peut on passer de cop-foot a cop-car ??? *)
    (* FIXME: optimisable avec invariant de bonne position. *)
    (node.nod_num = dest_node.nod_num 
	|| is_adjacent env.env_topo ptype node dest_node)
    && (dest_ptype = ptype || is_headquarter node)

let move_of_plan env plan =
  (plan.plan_ptype, get_node env.env_topo plan.plan_loc)

let is_valid_plan world env plan =
  let topo = env.env_topo in
  (* Pour le moment, nous ne considerons que les coups a n+1 *)
  let node, ptype = get_me env.env_info in
  let move = move_of_plan env plan in
    plan.plan_world = world.wor_wor + 1 && is_valid_move env move

(* Cette fonction est appelee lorsqu'on veut interpoler le prochain coup
   a partir d'un objectif. *)
let next_move_to_accomplish fw world env plan ptype node =
  let length, result = 
    Fw.shortest_path_next_step fw ptype 
      node.nod_num 
      (get_node env.env_topo plan.plan_loc).nod_num
  in
    match result with
	None -> 
	  ptype, node
      | Some result -> 
	  result.fns_ptype_one,
	  env.env_topo.t_nods.(result.fns_next)
  
  
  
