(* $Id: robber10.ml,v 1.1.2.2 2005/07/10 12:07:17 lefessan Exp $ *)


(* 

TODO list:

* Si on arrive a une banque en n mod 8 <> 0, on peut attendre qques tours
pour rentrer dans la banque uniquement en n mod 8 = 0.
* Si un flic reste a cote d'une banque, on ne s'interesse pas a cette banque.
* Ne pas aller systematiquement vers la banque la plus proche.
* Fixer les destinations une fois pour toute
*)

open Args
open Message
open Robber_types
open Robber_topology
open Robber
  
(* [init world_skeleton] initialises the state with the current world
skeleton *)
  

  
let initialized = ref false

open Graphics


let objectives = ref [188, 187; 190, 198; 198, 187; 200, 198; 200, 187]
  
let compute_node_value t w i =
  t.foot_dist.(i).(snd (List.hd !objectives))
  
let inform t w = 
  
  begin
    match !objectives with
    | (x, _) :: tail when x = w.state_num ->
        objectives := tail
    | _ -> ()
  end;
  
  let neighbours = t.robber_node :: t.foot_edges.(t.robber_node) in 
  let neighbours = List.map (fun i ->
        compute_node_value t w i, i        
    ) neighbours in
  
  let neighbours = List.sort compare neighbours in
  let next_node = snd (List.hd neighbours) in
  t.proposed_robber_node <- next_node;
  
  Printf.fprintf stderr "\nCurrent position: %d\n" t.robber_node;
  Printf.fprintf stderr "Move sorted:\n";
  List.iter (fun ( a, num) ->
      Printf.fprintf stderr "    %d -> %d \n"
        num  a 
  ) neighbours;
  Printf.fprintf stderr "Next position: %d\n" next_node;
  flush stderr;
  []

  
let _ = 
  register_robber "robber10" 
    "robs and stay"
    {
    Robber1.basic_robber with
        robber_inform = inform;
    robber_sumcops = Robber_misc.sum_to_cops2;    
  }
