open Args
open Message

  (*
let try_do f arg =
  let cop =
    match !current_cop with
      None -> current_cop := Some Safe_cop.cop; Safe_cop.cop
    | Some cop -> cop
  in
  try
    f cop arg
  with e ->
      Printf.fprintf stderr "Exception %s in cop\n" (Printexc2.to_string e);
      current_cop := None;
      f Safe_cop.cop arg

let cop_init cop arg = cop.cop_init arg
let cop_inform cop arg = cop.cop_inform arg
let cop_planning cop arg = cop.cop_planning arg
let cop_voting cop arg = cop.cop_voting arg
let cop_moving cop arg = cop.cop_moving arg

let cop_automata () =
  register {
    reg_bot = our_cop_name;
    reg_ptype = Cop_foot;
  };
  let world_skeleton = Parser.world_skeleton Lexer.token lexbuf in
  Safe_cop.init world_skeleton;
  try_do cop_init world_skeleton;
  let rec iter () =
    let msg = Parser.world_or_game_over Lexer.token lexbuf in
    match msg with
      Game_over -> exit 0
    | World world ->
        ignore (Safe_cop.inform world);
        let inform = try_do cop_inform world in
        Message.inform inform;
        let from_inform = Parser.from_inform Lexer.token lexbuf in
        let plan = try_do cop_planning from_inform in
        Message.plan plan;
        let from_plan = Parser.from_plan Lexer.token lexbuf in
        let vote = try_do cop_voting from_plan in
        Message.vote vote;
        let vote_res = Parser.vote_res Lexer.token lexbuf in
        let move = try_do cop_moving vote_res in
        Message.move move;
        iter ()
  in
  iter ()
*)

let main () =

  Arg.parse [
    (*
    "-safe_cop", Arg.Unit (fun _ -> current_cop := Some Safe_cop.cop),
    " : run as the 'Safe_cop' cop";
    "-random_cop", Arg.Unit (fun _ -> current_cop := Some Random_cop.cop),
    " : run as the 'Random_cop' cop";
    "-alain_cop", Arg.Unit (fun _ -> current_cop := Some Alain_cop.cop),
    " : run as the 'Alain_cop' cop";
    "-cop", Arg.Unit (fun _ -> current_cop := Some Cop.cop),
" : run as the 'Cop' cop (not implemented yet)";
  *)
    "-robber", Arg.String (fun s -> 
        try
          Robber.current_robber := Some (fst (Hashtbl.find Robber.robbers s))
        with Not_found ->
            Printf.fprintf stderr "No such robber. Existing robbers:\n";
            Hashtbl.iter (fun name (r, help) ->
                Printf.fprintf stderr "  %s: %s\n" name help
            ) Robber.robbers;
            flush stderr
    ), 
    " : run as the 'Robber' robber (not implemented yet)";
    "-x11_foot", Arg.Set x11_foot, " : display foot distance";
    "-x11", Arg.Set x11_map, " : display map";
    "-x11_car", Arg.Set x11_car, " : display car roads";
    "-x11_dist", Arg.Int ( (:=) x11_dist), " : display distances to HQ";
    "-x11_num", Arg.Set x11_num, " : display node numbers";
    "-x11_copsum", Arg.Set x11_copsum, " : display sum to cops";
    "-no_err", Arg.Unit (fun _ ->

        let fd = Unix.openfile "/dev/null" [Unix.O_WRONLY] 0o644 in
        Unix.dup2 fd Unix.stderr;
        Unix.close fd

    ), " : remove stderr output";
    "-random", Arg.Int Random.init, "<seed> : seed PRNG";
    ]
    (fun _ -> failwith "No anonymous argument")
  "main: our robot";
  match !Robber.current_robber with
    Some rob -> Robber.robber_automata rob
  | None -> failwith "You must specify a robber name"

let _ =
  try
    main ()
  with e ->
      Printf.fprintf stderr "Exception %s in main"
        (Printexc2.to_string e);
      exit 2
